
// A fallback build order for the standard ruleset.

function buildOrder_StandardFallback() {
	var ret = scopeRatings();
	var myDroids = myStrength();
	var derrickCount = countFinishedStructList(structures.derricks);
	if(derrickCount>23)
		derrickCount = 23;
	if(derrickCount > 17)
		dc2 =17;
	else
		dc2 = derrickCount;

	if (buildMinimumDerricks(1)) return true;
	if (buildMinimum(structures.gens, 1)) return true;
	if (buildMinimum(structures.factories, 1)) return true;
	if (buildMinimum(structures.labs, 1)) return true;
	if(ret.land+ret.sea>0) 
		if (buildMinimum(structures.factories, 2)) return true;
	if (buildMinimumDerricks(4)) return true;
	if (buildMinimum(structures.hqs, 1)) return true;
	if (buildMinimum(structures.labs, 2)) return true;
	if(ret.land+ret.sea>0 && derrickCount>5) 
		if (buildMinimum(structures.factories, Math.floor(derrickCount/4))) return true;

 	if(isAvailable("A0RepairCentre3") && myDroids >5)
		if (buildMinimumSensors([structures.repair[0],], 1)) return true;
	
	if(ret.land > 0 && isAvailable("A0CyborgFactory") && derrickCount<7)
		if (buildMinimum(structures.templateFactories, 1)) return true;

	if(ret.land > 0 && isAvailable("A0CyborgFactory") && derrickCount>6)
		if (buildMinimum(structures.templateFactories, Math.floor(derrickCount/4))) return true;

  	if(isAvailable("A0RepairCentre3") && myDroids >20)
		if (buildMinimumSensors([structures.repair[0],], 2)) return true;

	if(buildMinimum(structures.labs, dc2/3)) return true;

	
	if(iHaveVtol() && derrickCount <7 && ret.land+ret.sea>0)
		if(buildMinimum(structures.vtolFactories, 1)) return true;

	if(iHaveVtol() && derrickCount >7 && ret.land+ret.sea>0)
		if(buildMinimum(structures.vtolFactories, Math.floor(derrickCount/4))) return true;
	
	if(ret.land+ret.sea ===0) 
		if(buildMinimum(structures.labs, 5)) return true;
	
	if(ret.land+ret.sea ===0 &&iHaveVtol()) 
		if(buildMinimum(structures.vtolFactories, 3)) return true;

	if(isAvailable("A0VtolPad"))
		if(buildMinimum(structures.vtolPads, countStruct(structures.vtolFactories,me))) return true;
	
	// sensors in the base to extend visibility
	// added in mydroids condition to ensure that it focuses on building modules
	// so that it can build droids on t2 or t3 starts.
	// otherwise it will build the sensors first and it won't be abe to build droids 
	// untill the modules are build later in the process
	if(isAvailable("Sys-CB-Tower01") && weHaveArty === true && myDroids >10) 
		if(buildMinimumSensors([structures.sensors[1],],2)) return true;
	
	
	if(isAvailable("Sys-RadarDetector01") && myDroids >10) 
		if(buildMinimumSensors([structures.sensorRD,],1)) return true;
	
	if(isAvailable("ECM1PylonMk1") && myDroids >10) 
		if(buildMinimumSensors([structures.ECM,],3)) return true;  
	
   	//this sensor is not included amongst those buit around dericks
	if(isAvailable("Sys-VTOL-RadarTower01") && !isAvailable("Sys-SensoTowerWS") && myDroids >10) 
 		if(buildMinimumSensors([structures.sensorVTOL[0],],1)) return true;
	
	if(isAvailable("Sys-VTOL-CB-Tower01")  && !isAvailable("Sys-SensoTowerWS") && myDroids >10) 
     	//this sensor is not included amongst those buit around dericks
      	if(buildMinimumSensors([structures.sensorVTOL[1],],1)) return true;
    
	if(isAvailable("Sys-SensoTowerWS") && myDroids >10) 
		if(buildMinimumSensors([structures.sensorWS,],2)) return true;
  
	return false; //true; //captureSomeOil();
}
