
/*
 * This file includes event definitions only.
 * 
 */

function eventStartLevel() {
	queue("setTimers", me * 100);
	if (alliancesType === ALLIANCES_TEAMS) {
		// initialize subpersonality pseudo-randomly here
		// to make sure teammates have the same personality
		var j = 1, s = 0;
		for (var i = 0; i < maxPlayers; ++i) {
			if (allianceExistsBetween(me, i))
				s += j;
			j *= 2;
		}
		// the random "s" number obtained here is the same for all players in any team
		var s = s + (new Date()).getMinutes();
		j = 0;
		for (var i in subpersonalities) // count the amount of subpersonalities
			++j;
		s = s % j;
		j = 0;
		for (var i in subpersonalities) {
			if (j === s)
				personality = subpersonalities[i];
			++j;
		}
	} else {
		// if teams are not sharing research, or there are no teams at all,
		// initialize the subpersonality randomly and don't care
		personality = randomItem(subpersonalities);
	}
	base = calculateLocation();
	pVTOL = patrolVTOL();
	enemiesAreHere = false;  // are there enemies close to the base
	areWePanicked = false;	// are there a lot of enemies close to the base
	enemyHasVTOL = false;
	weHaveArty = false;
	weHaveAA = false;
	rally = whereToRally();
	//adding function to randomise hover preference
	personality.hitandrun = withChance(personality.hover);
	//personality.ind_def = random(10)-5;   // randomly make the ai either a little bit more or less defensive
	personality.VTOLtime = 0;
	// the following code is necessary to avoid some strange game bug when droids that 
	// are initially buried into the ground fail to move out of the way when a building 
	// is being placed right above them
	enumTrucks().forEach(function(droid) {
		orderDroidLoc(droid, DORDER_MOVE, droid.x + random(3) - 1, droid.y + random(3) - 1);
	});
}

function eventDroidBuilt(droid, structure) {
	groupDroid(droid);
}

function eventStructureBuilt(structure) {
	queue("checkConstruction");
}

function eventAttacked(victim, attacker) {
	if (attacker === null)
		return; // no idea why it happens sometimes
	if (isAlly(attacker.player))
		return; // don't respond to accidental friendly fire
	if(throttled(1000, victim.id))
		return;
	if(distance(attacker, victim) < 20){
		if (victim.type === DROID && victim.droidtype !== DROID_CONSTRUCT){ 
			if (!isVTOL(victim) && defined(victim.group) && victim.group !== defGroup && victim.health > personality.repairAt+(100 - personality.repairAt)*0.7) {
				if(attacker.type === DROID && !isVTOL(attacker) || attacker.type === STRUCTURE){
					setTarget({ x: attacker.x, y: attacker.y, type: POSITION },victim.group,true);
					touchGroup(victim.group);
					return;
				}
			} else 	if (!isVTOL(victim) && defined(victim.group) && victim.group !== defGroup && victim.health <= personality.repairAt+(100 - personality.repairAt)*0.7) {
				if(attacker.type ===DROID && !isVTOL(attacker) || attacker.type === STRUCTURE){
					fallBack(victim, attacker);
					setTarget({ x: attacker.x, y: attacker.y, type: POSITION },victim.group,true);
					touchGroup(victim.group);
					return;
				}
			} else if(!isVTOL(victim) && victim.group === defGroup && victim.health < personality.repairAt+(100 - personality.repairAt)*0.7){
				fallBack(victim, attacker);
				return;
			} else if (isVTOL(victim) ) {
				if(victim.health < personality.repairAt || victim.order === DORDER_REARM){
					orderDroid(victim, DORDER_REARM);
					return;
				}
				if( vtolCanHit(victim, attacker) && !throttled(5000, victim.id)){
					//orderDroidObj(victim, DORDER_ATTACK, attacker);
					pushVtols(attacker.x,attacker.y);
					return;
				}
			}
		} else if (victim.type === STRUCTURE && areWePanicked !== true ) {  
			if (throttled(5000, victim.id) )
				return;
			if(attacker.type ===DROID && isVTOL(attacker))
				return;
			setTarget({ x: attacker.x, y: attacker.y, type: POSITION, timeSet: gameTime }, miscGroup);
			setTarget({ x: attacker.x, y: attacker.y, type: POSITION, timeSet: gameTime },any);
		}
	}
}

function eventStructureReady(structure) {
	fireLassat(structure);
}

function eventChat(from, to, message) {
	// we are not case-sensitive
	message = message.toLowerCase();
    handleChatMessage(from, to, message)
}

function eventObjectTransfer(object, from) {
	if (object.player !== me)
		return; // object was transferred from me, not to me
	if (object.type === DROID)
		groupDroid(object);
}

function eventBeacon(x, y, from, to) {
	noticeBeacon(x, y, from);
}

function eventBeaconRemoved(from, to) {
	unnoticeBeacon(from);
}

function eventDestroyed(object) {
	if (isEnemy(object.player))
		pushVtols(object.x,object.y);
}

function eventResearched(research){
	if(gameTime >10){
		if(isAvailable("A0VTolFactory1") && !isAvailable("A0VtolPad")){
			personality.VTOLtime = gameTime;
		}
	}
}

function eventDroidIdle(droid) {
	if(droid.player === me) {
		if(defined(droid) && (isVTOL(droid))) {
			//loc = patrolVTOL();
			if(base.x1===0 && base.y1 ===0){
				if(withChance(50)){
					orderDroidLoc(droid, DORDER_SCOUT, pVTOL.x1, pVTOL.y1);
				} else {
					orderDroidLoc(droid, DORDER_SCOUT, pVTOL.x1-20, pVTOL.y1+20);
				}
			} else {
				orderDroidLoc(droid, DORDER_SCOUT, pVTOL.x1, pVTOL.y1);
			}
			if(droid.x > pVTOL.x1 -10 && droid.x < pVTOL.x1+10 && droid.y > pVTOL.y1 -10 && droid.y < pVTOL.y1+10 ){
				orderDroidLoc(droid, DORDER_PATROL, pVTOL.x2, pVTOL.y2);
				return;
			}
			if(droid.x > pVTOL.x2 -10 && droid.x < pVTOL.x2+10 && droid.y > pVTOL.y2 -10 && droid.y < pVTOL.y2+10 ){
				orderDroidLoc(droid, DORDER_PATROL, pVTOL.x1, pVTOL.y1);
				return;
			}
			if(droid.x > pVTOL.x1-20 -10 && droid.x < pVTOL.x1-20+10 && droid.y > pVTOL.y1+20 -10 && droid.y < pVTOL.y1+20+10 ){
				orderDroidLoc(droid, DORDER_PATROL, pVTOL.x2+20, pVTOL.y2-20);
				return;
			}
		}
	}
}

