
/*
 * This file describes building construction procedures.
 * 
 */

(function(_global) {
////////////////////////////////////////////////////////////////////////////////////////////


function randomLocation() {
	//var base= calculateLocation();
	var x, y;
	do {
		x = base.x3 + random(baseScale) - baseScale / 2;
		y = base.y3 + random(baseScale) - baseScale / 2;
		}
 	 while (x < 3 || y < 3 || x > mapWidth - 4 || y > mapHeight - 4);
	return {x: x, y: y};
	
}


function randomLocationER(border, xR) {
  	// goal is to select a random location within an area that is increasing over time
  	// border is how close to the map edge we want to place stuff
  	// minR is how close to the center do we eant to place stuff
 	var diameter = baseDiameter() ;
	var maxR = diameter * baseScale /2;
	var minR = baseScale* baseDiameterMin() * xR;
	var x,y;
	var r;
	var angle = 0;
	if(minR > maxR)
		maxR = minR +2;
		var buildSpot=0;

	for(var i = 0; i<100; ++i){
		r = minR+ Math.random() * (maxR-minR);
		// if it's in a corner then use a 150 degree arc for aa and arty (90 + 30 either side)
		// if it's on an edge  but not a corner then use a 240 degree arc (180 + 30 either side)
		// if it's located somewhere central then use a 360 degree arc
		// degrees converted to radians
		// why oh why isn't x = 0, y = 0, the bottom left corner?
		if(base.x1 === -1 && base.y1 === -1) { // se corner
			// aprox angle between 150 and 300 degrees
			angle = Math.random() * 0.833 * Math.PI + 0.833 * Math.PI;
		}
		if(base.x1 === 1 && base.y1 === 1) { // nw corner
			// aprox angle between 330 and 120 degrees
			angle = Math.random() * 0.833 * Math.PI;
			if(angle > 0.67* Math.PI)
				angle = angle - 0.67* Math.PI + 1.833 *Math.PI ;
		}
		if(base.x1 === 1 && base.y1 === -1){// sw corner
		// aprox angle between 240 and 30 degrees
			angle = Math.random() * 0.833 * Math.PI + 1.33 * Math.PI;
			if(angle > 2* Math.PI)
				angle = angle - 2* Math.PI;
		}
		if(base.x1 === -1 && base.y1 === 1){ //ne corner x < 
			// aprox angle between 60 and 210 degrees
			angle = Math.random() * 0.833 * Math.PI + 0.33 * Math.PI;
		}

		if(base.x1 === -1 && base.y1 === 0) { // eastern edge centralish on NS border
			// aprox angle between 60 and 300 degrees
			angle = Math.random() * 1.33* Math.PI+0.33*Math.PI;
		}
		if(base.x1 === 1 && base.y1 === 0) { // western edge centralish on NS border
			// aprox angle between 240 and 120 degrees
			angle = Math.random() * 1.33 * Math.PI;
			if(angle > 0.667 * Math.PI)
				angle = angle - 0.667* Math.PI +1.33 * Math.PI;
		}
		if(base.x1 === 0 && base.y1 === -1) { // southern edge centralish ew border
			// aprox angle between 150 and 30 degrees
			angle = Math.random() *  1.33 * Math.PI +  0.83 *Math.PI;
			if(angle > 2* Math.PI)
				angle = angle - 2* Math.PI;
		}
		if(base.x1 === 0 && base.y1 === 1) { // northern edge centralish ew border
			// aprox angle between 330 and 210 degrees
			angle = Math.random() * 1.33 * Math.PI ;
			if(angle > 1.166* Math.PI)
				angle = angle - 1.166* Math.PI+ 1.833 *Math.PI ;
		}

		if(base.x1 === 0 && base.y1 === 0) { // somewhere central
			// aprox angle between 0 and 360 degrees
			angle = Math.random() *2 * Math.PI ;
		}	

		y = base.y3 + Math.floor(r * Math.sin( angle ) );
		x = base.x3 + Math.floor(r * Math.cos( angle ) );
		if(x> border && x < mapWidth-border && y > border && y < mapHeight-border)
			if(terrainType(x,y) !== TER_CLIFFFACE && terrainType(x,y) !== TER_WATER &&
					terrainType(x+1,y+1) !== TER_CLIFFFACE && terrainType(x+1,y+1) !== TER_WATER &&
					terrainType(x-1,y-1) !== TER_CLIFFFACE && terrainType(x-1,y-1) !== TER_WATER &&
					terrainType(x+1,y-1) !== TER_CLIFFFACE && terrainType(x+1,y-1) !== TER_WATER &&
					terrainType(x-1,y+1) !== TER_CLIFFFACE && terrainType(x-1,y+1) !== TER_WATER)
				buildSpot = 1;
			else
				buildSpot =0;
			
		if(x> border && x < mapWidth-border && y > border && y < mapHeight-border && buildSpot ===1){
			break;	
		}
	}

	if( x <= border || x >= mapWidth-border || y <= border || y >= mapHeight-border || buildSpot === 0){ 
		x = base.x3;
		y = base.y3;
	}
	return {x: x, y: y};
}

// a function for checking the presence of enemy units at the construction site
function safeSpot(x, y) {
	return dangerLevel({x: x, y: y}) <= 0;
}

_global.truckFree = function (truck) {
	if (truck.droidType !== DROID_CONSTRUCT)
		return false;
	if (truck.order === DORDER_BUILD)
		return false;
	if (truck.order === DORDER_HELPBUILD)
		return false;
	if (truck.order === DORDER_LINEBUILD)
		return false;
	if (truck.order === DORDER_DEMOLISH)
		return false;
	if (truck.order === DORDER_REPAIR)
		return false;

	return true;
}

// returns one or two free trucks
function getTwoFreeTrucks() {
	var trucks = enumTrucks().filter(truckFree);
	if (trucks.length > 2) {
		var ret = naiveFindClusters(trucks, baseScale / 2);
		if (ret.maxCount >= 2)
			trucks = ret.clusters[ret.maxIdx];
	}
	if (trucks.length > 2)
		trucks.length = 2;
	return trucks;
}

function getFreeTruckAround(x, y) {
	var list = enumTrucks().filter(truckFree).filter(function(droid) { 
		return droidCanReach(droid, x, y); 
	}).sort(function(one, two) {
		return distance(one, x, y) - distance(two, x, y);
	});
	if (list.length > 0)
		return list[0];
}

function buildModule(struct) {
	trucks = getTwoFreeTrucks();
	if (trucks.length <= 0)
		return BUILDRET.FAILURE;
	var moduleInfo = modules.filter(function(item) { return isAvailable(item.module) && item.base === struct.stattype; }).last();
	if (!defined(moduleInfo))
		return BUILDRET.UNAVAILABLE;
	if (struct.modules >= moduleInfo.count)
		return BUILDRET.UNAVAILABLE;
	var success = false;
	for (var i = 0; i < trucks.length; ++i) 
		success = orderDroidBuild(trucks[i], DORDER_BUILD, moduleInfo.module, struct.x, struct.y) || success;
	if (success)
		return BUILDRET.SUCCESS;
	return BUILDRET.FAILURE;
}


function buildBasicStructure(statlist, importance) {
	if (!defined(importance))
		importance = IMPORTANCE.MANDATORY;
	trucks = getTwoFreeTrucks();
	if (trucks.length <= 0)
		return BUILDRET.FAILURE;
	// choose structure type (out of the statlist), 
	// together with suitable location
	// trying to reduce double up by making sure trucks that queue buildings in the base are close to the base
	// otherwise another once can be started while it's moving to the base
	//if(distanceToBase(trucks[0]) >baseScale*0.75){
	//	orderDroidLoc(trucks[0], DORDER_MOVE, base.x3,base.y3);  
	//	return BUILDRET.FAILURE;
	//}
	var idx, loc, avail = false,rndLoc,i;
	for (i = 0; i < statlist.length; ++i)
		if (isAvailable(statlist[i])) {
			avail = true;
			if (distanceToBase(trucks[0]) <= baseScale/2 && statlist[i])
				loc = pickStructLocation(trucks[0], statlist[i], trucks[0].x, trucks[0].y);
			else  {
				rndLoc = randomLocation();
				loc = pickStructLocation(trucks[0], statlist[i],rndLoc.x, rndLoc.y);
			}
			idx = i;
			break;
		}
	if (!avail)
		return BUILDRET.UNAVAILABLE;
	if (!defined(loc)) 
		return BUILDRET.UNAVAILABLE;
	if(loc.x > rally.x-3 && loc.x < rally.x+3 && loc.y > rally.y-3 && loc.y < rally.y+3)
		return BUILDRET.UNAVAILABLE;
	//if(distance(loc,base.x3,base.y3)> baseScale*baseDiameter() )
	//	return BUILDRET.FAILURE; //if things are wrong, lets stop them from going really wrong
		// it appears that pickStructLocation can default to a value close to an edge if terrain gets in the way
	if (throttled(35000, statlist[0])) return BUILDRET.UNAVAILABLE;
	// by default, don't try building things in dangerous locations
	if (importance === IMPORTANCE.PEACETIME && !safeSpot(loc.x, loc.y))
		return BUILDRET.FAILURE;
	// now actually build
	var success = false;
	//chat(ALLIES, loc.x + "~" + loc.y);
	for (i = 0; i < trucks.length; ++i) 
		success = orderDroidBuild(trucks[i], DORDER_BUILD, statlist[idx], loc.x, loc.y) || success;
	if (success)
		return BUILDRET.SUCCESS;
	return BUILDRET.FAILURE;
}

function buildStructureAA(statlist, importance) {
  if (throttled(5000, statlist[0])) return BUILDRET.FAILURE;
	// by default, don't try building things in dangerous locations
	if (!defined(importance))
		importance = IMPORTANCE.MANDATORY;
	trucks = getTwoFreeTrucks();
	if (trucks.length <= 0)
		return BUILDRET.FAILURE;
	// choose structure type (out of the statlist), 
	// together with suitable location
	var idx, loc, avail = false,i, rndLoc;
	statlist = statlist.reverse(); // 
	for (i = 0; i < statlist.length; ++i)
		if (isAvailable(statlist[i])) {
			avail = true;
			idx = i;
			break;
		}
	if (!avail)
		return BUILDRET.UNAVAILABLE;
	if(statlist[idx] === "WallTower-DoubleAAGun" || statlist[idx] === "WallTower-SamSite" || statlist[idx] === "WallTower-SamHvy" ||
			statlist[idx] === "WallTower-QuadRotAAGun" || statlist[idx] === "WallTower-TwinAssaultGun"){
		var walls = [];
		walls = walls.concat(enumStruct(me,WALL),enumStruct(me,"A0HardcreteMk1CWall")).sort(function(i,j) {
			return distance(i.x,i.y,mapWidth/2,mapHeight/2) - distance(j.x,j.y,mapWidth/2,mapHeight/2);
			});
		if(walls.length > 0 && withChance(50)) {
			loc = walls[0];
		} else {
			rndLoc = randomLocationER(5,0.5);
			loc = pickStructLocation(trucks[0], statlist[i],rndLoc.x, rndLoc.y);
			if (!defined(loc)) 
				return BUILDRET.UNAVAILABLE;
			if(loc.x > rally.x-3 && loc.x < rally.x+3 && loc.y > rally.y-3 && loc.y < rally.y+3)
				return BUILDRET.UNAVAILABLE;
		}
	} else {
		rndLoc = randomLocationER(5,0.4);
		loc = pickStructLocation(trucks[0], statlist[i],rndLoc.x, rndLoc.y);
		if (!defined(loc)) 
			return BUILDRET.UNAVAILABLE;
		if(loc.x > rally.x-3 && loc.x < rally.x+3 && loc.y > rally.y-3 && loc.y < rally.y+3)
			return BUILDRET.UNAVAILABLE;
	}
	if (importance === IMPORTANCE.PEACETIME && !safeSpot(loc.x, loc.y))
		return BUILDRET.FAILURE;
	// now actually build
	var success = false;
	for (i = 0; i < trucks.length; ++i) 
		success = orderDroidBuild(trucks[i], DORDER_BUILD, statlist[idx], loc.x, loc.y) || success;
	if (success)
		return BUILDRET.SUCCESS;
	return BUILDRET.FAILURE;
}

function buildStructureArty(statlist, importance) {
 if (throttled(5000, statlist[0])) return BUILDRET.FAILURE;
	// by default, don't try building things in dangerous locations
	if (!defined(importance))
		importance = IMPORTANCE.MANDATORY;
	trucks = getTwoFreeTrucks();
	if (trucks.length <= 0)
		return BUILDRET.FAILURE;
	// choose structure type (out of the statlist), 
	// together with suitable location
	var idx, loc, avail = false,i, rndLoc;
	statlist = statlist.reverse(); // 
	for (i = 0; i < statlist.length; ++i)
		if (isAvailable(statlist[i])) {
			avail = true;
			idx = i;
			break;
		}
	if (!avail)
		return BUILDRET.UNAVAILABLE;
	rndLoc = randomLocationER(0,0.4);
	loc = pickStructLocation(trucks[0], statlist[i],rndLoc.x, rndLoc.y);
	if (!defined(loc)) 
		return BUILDRET.UNAVAILABLE;
	if(loc.x > rally.x-3 && loc.x < rally.x+3 && loc.y > rally.y-3 && loc.y < rally.y+3)
		return BUILDRET.UNAVAILABLE;
	if(statlist[idx] === "Emplacement-RotHow" && isAvailable("Emplacement-Howitzer150")){
		if(withChance(50)) {
			idx = idx+1;
		}
	}  // want a mix of hellstorm and groundshakers
	if (importance === IMPORTANCE.PEACETIME && !safeSpot(loc.x, loc.y))
		return BUILDRET.FAILURE;
	// now actually build
	var success = false;
	for (i = 0; i < trucks.length; ++i) 
		success = orderDroidBuild(trucks[i], DORDER_BUILD, statlist[idx], loc.x, loc.y) || success;
	if (success)
		return BUILDRET.SUCCESS;
	return BUILDRET.FAILURE;
}


function buildStructureSensor(sensor, importance) {
  // for placing sensors in base
  // try to make sure that they aren't too close together
  if (throttled(35000, sensor)) return BUILDRET.FAILURE;
	// by default, don't try building things in dangerous locations
	if (!defined(importance))
		importance = IMPORTANCE.MANDATORY;
	trucks = getTwoFreeTrucks();
	if (trucks.length <= 0)
		return BUILDRET.FAILURE;
	// together with suitable location
	if(distanceToBase(trucks[0]) >baseScale*0.75){
		orderDroidLoc(trucks[0], DORDER_MOVE, base.x3,base.y3);  
		return BUILDRET.FAILURE;
	}
	var loc, avail = true, rndLoc;
	if(sensor ==="ECM1PylonMk1"){
		rndLoc = randomLocationER(5,0.3);
	} else 	if(sensor ==="Sys-CB-Tower01"){
		rndLoc = randomLocationER(5,0.4);
	} else{
		rndLoc = randomLocationER(10,0.5);
	}
	loc = pickStructLocation(trucks[0], sensor,rndLoc.x, rndLoc.y);
	//chat(allies, "player:" + me +"  " +loc.x + "~" + loc.y + "~" +  rndLoc.x + "~" + rndLoc.y + "~" + base.x3 + "~" + base.y3);
	if (!defined(loc)) 
		return BUILDRET.FAILURE;
	if(loc.x > rally.x-3 && loc.x < rally.x+3 && loc.y > rally.y-3 && loc.y < rally.y+3)
		return BUILDRET.FAILURE;
	if (importance === IMPORTANCE.PEACETIME && !safeSpot(loc.x, loc.y))
		return BUILDRET.FAILURE;
	var list = enumStruct(me, sensor);
 	for (var i = 0; i < list.length; ++i)
	  if (distance(list[i], loc) < baseScale *0.7 && list.length>0) {
			 avail = false;
	  } 
	if (!avail)
		return BUILDRET.UNAVAILABLE;
	// now actually build
	var success = false;
	for (var i = 0; i < trucks.length; ++i) 
		success = orderDroidBuild(trucks[i], DORDER_BUILD, sensor, loc.x, loc.y) || success;
	if (success)
		return BUILDRET.SUCCESS;
	return BUILDRET.FAILURE;
}


function finishStructures() {
	var success = false;
	var list = enumStruct(me).filterProperty("status", BEING_BUILT);
	for (var i = 0; i < list.length; ++i) {
		if (success)
			return;
		if (throttled(10000, list[i].id))
			return;
		if (list[i].stattype === RESOURCE_EXTRACTOR)
			return;
		var truck = getFreeTruckAround(list[i].x, list[i].y);
		if (!defined(truck))
			return;
		if (orderDroidObj(truck, DORDER_HELPBUILD, list[i]))
			success = true;
	};
	return success;
}

function buildStructureAround(statlist, loc, unique) {
	if (!defined(statlist))
		return BUILDRET.UNAVAILABLE;
	var truck = getFreeTruckAround(loc.x, loc.y);
	if (!defined(truck))
		return BUILDRET.FAILURE;
	var z;
	var stat = statlist.filter(isAvailable).filter(function(s) {
		if (unique !== true)
			return true;
		var list = enumStruct(me, s);
		for (var i = 0; i < list.length; ++i)
			if (distance(list[i], loc) < baseScale*0.7 )
				return false;
		if(s === "A0RepairCentre3")
			if(distance(loc, base.x3,base.y3) < baseScale*0.7)
				return false;
		return true;
	}).last();
	if (!defined(stat))
		return BUILDRET.UNAVAILABLE;
	var loc2 = pickStructLocation(truck, stat, loc.x, loc.y);
	if (!defined(loc2))
		return BUILDRET.FAILURE;
	if(loc2.x > rally.x-3 && loc2.x < rally.x+3 && loc2.y > rally.y-3 && loc2.y < rally.y+3)
		return BUILDRET.FAILURE;
	// if we're not into turtling, don't build too many towers
	if (personality.defensiveness < 100 && distance(loc2, loc) > baseScale * ((personality.defensiveness/400)))  //original divided baseScale by 5
	  // as the personality gets more defensive then it'll buid structures further out (in principle)
		return BUILDRET.FAILURE;
 	if (orderDroidBuild(truck, DORDER_BUILD, stat, loc2.x, loc2.y)) 
		return BUILDRET.SUCCESS;
	return BUILDRET.FAILURE;
}


function captureOil(oil) {
	if (!defined(oil))
		return BUILDRET.FAILURE;
	var truck = getFreeTruckAround(oil.x, oil.y);
	if (!defined(truck))
		return BUILDRET.FAILURE;
	var stat = structures.derricks.filter(isAvailable).last();
	if (!defined(stat))
		return BUILDRET.UNAVAILABLE;
	if (throttled(90000, oil.y * mapWidth + oil.x))
		return BUILDRET.FAILURE;
	if (!safeSpot(oil.x, oil.y))
		return BUILDRET.FAILURE;  // lets try to stop trucks from suicide
	if (orderDroidBuild(truck, DORDER_BUILD, stat, oil.x, oil.y)) 
		return BUILDRET.SUCCESS;
	return BUILDRET.FAILURE;
}

function chooseDefense(defrole) {
	return weaponStatsToDefenses(chooseAvailableWeaponPathByRoleRatings(getProductionPaths(), chooseDefendWeaponRole(), 2, defrole), defrole);
}

function buildTowers() {
	var oils = enumStructList(structures.derricks);
	if (oils.length === 0)
		return false;
	if (withChance(70)) {
		return buildStructureAround(chooseDefense(DEFROLE.STANDALONE), oils.random()) !== BUILDRET.UNAVAILABLE;
		} else if(isAvailable("Sys-SensoTowerWS")) {
			return buildStructureAround(chooseDefense(DEFROLE.FORTRESS).concat(structures.repair,structures.sensorRD,
				structures.sensorWS,structures.ECM), oils.random(), true) !== BUILDRET.UNAVAILABLE;
		} else {
			return buildStructureAround(chooseDefense(DEFROLE.FORTRESS).concat(structures.repair,structures.sensorRD,
				structures.sensors,structures.ECM), oils.random(), true) !== BUILDRET.UNAVAILABLE;
		}  
}

function buildGateways() {
	var oils = countStructList(structures.derricks);
	if (oils <= 0)
		return BUILDRET.FAILURE;
	var gates = enumGateways().filter(function(gate) {
		var l = gate.x1 - gate.x2 + gate.y1 - gate.y2;
		if (l < 0)
			l = -l;
		var cnt = enumRange(gate.x1, gate.y1, l, ALLIES).filterProperty("stattype", DEFENSE).length;
		cnt    += enumRange(gate.x2, gate.y2, l, ALLIES).filterProperty("stattype", DEFENSE).length;
		cnt    -= enumRange(gate.x1, gate.y1, l, ENEMIES).filterProperty("stattype", DEFENSE).length;
		cnt    -= enumRange(gate.x2, gate.y2, l, ENEMIES).filterProperty("stattype", DEFENSE).length;
		return cnt >= 0 && (cnt < l || (personality.defensiveness === 100 && withChance(70))); // turtle AI needs to keep building towers
	}).sort(function(one, two) { return distanceToBase({x: one.x1, y: one.y1}) - distanceToBase({x: two.x1, y: two.y1}); });
	if (gates.length === 0)
		return;
	if (withChance(50))
		return buildStructureAround(chooseDefense(DEFROLE.GATEWAY), {x: gates[0].x1, y: gates[0].y1}) !== BUILDRET.UNAVAILABLE;
	else
		return buildStructureAround(chooseDefense(DEFROLE.GATEWAY), {x: gates[0].x2, y: gates[0].y2}) !== BUILDRET.UNAVAILABLE;
}

function buildArty() {
	return buildStructureArty(chooseDefense(DEFROLE.ARTY), IMPORTANCE.PEACETIME);
}

function buildAntiAir() {
	return buildStructureAA(chooseDefense(DEFROLE.ANTIAIR), IMPORTANCE.PEACETIME);
}

_global.buildMinimum = function(statlist, count, importance) {
	if (countStructList(statlist) < count)
		if (buildBasicStructure(statlist, importance) !== BUILDRET.UNAVAILABLE)
			return true;
	return false;
}

_global.buildMinimumSensors = function(statlist, count, importance) {
		// goal is to get the ai to build a  specific number of sensors in its base once they're available, 
		// It will build more as part of towers function out from the base
		if (countStructuresBase(statlist) < count){
			if (buildStructureSensor(statlist, importance) !== BUILDRET.UNAVAILABLE)
				return true;
		}
		return false;
}

function countStructuresBase(statlist){
	function uncached() {
		var list = enumStructList(statlist),countObject=0;
		for (var i = 0; i < list.length; ++i)
			if (distance(list[i], base.x3,base.y3) < baseScale)
				++countObject;
		return countObject;			
	}
	return cached(uncached, 2000,statlist)
}

_global.captureSomeOil = function() {
	if (throttled(500))
		return false;
	function getOilList() {
		var oils = [];
		oilResources.forEach(function(stat) { oils = oils.concat(enumFeature(-1, stat)); });
		oils = oils.concat(enumStructList(structures.derricks).filterProperty("status", BEING_BUILT));
		//oils= oils.filter(function (f){return !isNearFriendlyBase(f); });  // added to stop ai stealing oils
		oils = oils.sort(function(one, two) {
			return distanceToBase(one) - distanceToBase(two);
		});
		if (oils.length > 10)
			oils.length = 10;
		return oils;
	}
	var oils = cached(getOilList, 5000);
	if (countFinishedStructList(structures.derricks) >= 4 * structListLimit(structures.gens))
		return false;
	oils= oils.filter(function (f){return !isNearFriendlyBase(f); });
	for (var i = 0; i < oils.length; ++i)
		if (captureOil(oils[i]) === BUILDRET.SUCCESS)
			return true;
	return false;
}

_global.buildMinimumDerricks = function(count) {
	if (countFinishedStructList(structures.derricks) < count)
		if (captureSomeOil())
			return true;
	return false;
}

function buildExpand() {
	if (myPower() > personality.maxPower && gameTime >300000 ) {
		switch (chooseObjectType()) {
			case 0:
				if (needFastestResearch() === PROPULSIONUSAGE.GROUND)
					if (buildMinimum(structures.factories, Infinity, IMPORTANCE.PEACETIME))
						return true;
				// fall-through
			case 1:
				if (needFastestResearch() === PROPULSIONUSAGE.GROUND)
					if (buildMinimum(structures.templateFactories, Infinity, IMPORTANCE.PEACETIME))
						return true;
				// fall-through
			case 3:
				if (buildMinimum(structures.vtolFactories, Infinity, IMPORTANCE.PEACETIME))
					return true;
		}
	}
	return false;
}

function buildEnergy() {
	var oils = countFinishedStructList(structures.derricks);
	var gens = countStructList(structures.gens);
	if (oils > 4 * gens)
		if (buildBasicStructure(structures.gens, IMPORTANCE.PEACETIME) !== BUILDRET.UNAVAILABLE)
			return true;
	if (withChance(50))
		if (captureSomeOil())
			return true;
	return false;
}

function buildModules() {
	var str = [];
	for (var i = 0; i < modules.length; ++i) {
		if (modules[i].base === FACTORY && needFastestResearch() !== PROPULSIONUSAGE.GROUND )
			continue;
		str = enumStruct(me, modules[i].base);
		for (var j = 0; j < str.length; ++j)
			if (buildModule(str[j]) !== BUILDRET.UNAVAILABLE)
				return true;
	}
	return false;
}

_global.buildVtols = function() {
	if (buildMinimum(structures.vtolPads, enumDroid(me, DROID_WEAPON).filter(isVTOL).length / 2), IMPORTANCE.PEACETIME)
		return true;
	return false;
}

function buildExtras() {
	if (throttled(180000))
		return false;
	if (buildBasicStructure(structures.extras, IMPORTANCE.PEACETIME) !== BUILDRET.UNAVAILABLE)
		return true;
	return false;
}

_global.buildDefenses = function() {
	if (chooseObjectType() !== 2)
		return false;
	
	// do I ve AA or arty?
	if(!throttled(23051, "arty")) {
		if(weHaveArty === false) 
			weHaveArty = iHaveArty();  //once it has arty won't need to evaluate again
	}
	if(!throttled(26322, "aa"))	{
		if(weHaveAA ===false) 
			weHaveAA = iHaveAA();  //once it has AA won't need to evaluate again
	}
	
	var chanceAA, chanceGW, chanceAR, scaleAA, scaleGW, scaleAR;
	chanceAA = 12.5;  // inintially lower chance to build aa (so that the base is not swamped with aa)
	chanceGW = 25;
	chanceAR = 33;
	if( enemyHasVTOL === true && (gameTime-VTOLspottedTime) > 600000 && weHaveAA ===true) {
		chanceAA = 50;
		chanceGW = 25;
		chanceAR = 33; 
	}
	
 	if( enemyHasVTOL === true && (gameTime-VTOLspottedTime) < 600000 && weHaveAA ===true) {
		// increased chance of choosing AA closer to when VTOL was spotter and then decreasing to to 25% overall (assuming gateways are present and it has Arty)
		scaleAA = (600000 - (gameTime-VTOLspottedTime)) * (50/600000);
		scaleGW = (600000 - (gameTime-VTOLspottedTime)) * (25/600000);
		scaleAR = (600000 - (gameTime-VTOLspottedTime)) * (33/600000);
		chanceAA = 50 + scaleAA;
		chanceGW = 25 - scaleGW;
		chanceAR = 33 - scaleAR; 
	}
	
	if(weHaveArty===true && weHaveAA ===false){
		chanceAA = 0;
		chanceGW = 33;
		chanceAR = 50;
	}
	
	if(weHaveArty===false && weHaveAA ===false){
		// 50% chance of building gateways or towers
		chanceAA = 0;
		chanceGW = 50;
		chanceAR = 0;
	}

	
	if (withChance(chanceGW) && areThereGW()===true) {
		if (buildGateways()) 
			return true;
	} else  if (withChance(chanceAR) && weHaveArty ===true) {
		if (buildArty()) 
			return true;
	} else if (withChance(chanceAA) && weHaveAA===true) {
		if (buildAntiAir())  
			return true;
	} else if (buildTowers()) // includes sensor towers and forts
			return true;
	return false;
}

function iHaveArty (){
	if(chooseDefense(DEFROLE.ARTY).length>0)
		return true;
	return false;
}
function iHaveAA(){
	if(chooseDefense(DEFROLE.ANTIAIR).length>0)
		return true;
	return false;
}
	

function listOutdatedDefenses() {
	for (var path in weaponStats) {
		for (var role in DEFROLE) {
			var list = weaponStatsToDefenses(weaponStats[path], DEFROLE[role]);
			for (var i = 0; i < list.length - 2; ++i)
				if (isAvailable(list[i + 2])) {
					if (countStruct(list[i]) > 0)
						return enumStruct(me, list[i]);
				}
		}
	};
	return [];
}

function recycleDefenses() {
	if (throttled(9230))
		return false;
	var trucks = enumTrucks().filter(truckFree);
	if (trucks.length <= 0)
		return false;
	var list = listOutdatedDefenses();
	if(list.length > 0){
		for (var i = 0; i < list.length; ++i)
			for (var j = 0; j < trucks.length; ++j)
				if (droidCanReach(trucks[j], list[i].x, list[i].y)) {
					orderDroidObj(trucks[j], DORDER_DEMOLISH, list[i]);
					return true;
				}
	}
	var walls= [];
	if(baseType !== CAMP_CLEAN ){
		walls= walls.concat(enumStruct(me,WALL), enumStruct(me, "A0HardcreteMk1CWall"));
		if(walls.length > 0){
			walls = walls.filter(function(j) {return distance(j.x,j.y,mapWidth/2,mapHeight/2) > distance(base.x3,base.y3,mapWidth/2,mapHeight/2);});
			// demolish walls between mapedge and hq leave walls that are between the hq and map center
			// should free up some space for base expansion on some maps
			for (var i = 0; i < walls.length; ++i)
				for (var j = 0; j < trucks.length; ++j)
					if (droidCanReach(trucks[j], walls[i].x, walls[i].y)) {
						orderDroidObj(trucks[j], DORDER_DEMOLISH, walls[i]);
						return true;
					}		
		}
	}
	return false;
}

function repairBuildings() {
	if (throttled(7500))
		return false;
	var trucks = enumTrucks().filter(truckFree).sort(distanceToBase);
	if (trucks.length <= 0)
		return false;
	var list =enumStruct(me).filter(function(obj) {return obj.health < 100;}).sort(distanceToBase);
	if(list.length>0){
		for (var i = 0; i < list.length; ++i)
			for (var j = 0; j < trucks.length; ++j)
				if (safeSpot(list[i].x, list[i].y)) {
					if (droidCanReach(trucks[j], list[i].x, list[i].y)) {
						orderDroidObj(trucks[j], DORDER_REPAIR, list[i]);
						return true;
					}
				}
	}
	return false;	
}

_global.checkConstruction = function() {
	// if the enemy has vtol then we might need aa
	if(enemyHasVTOL===false) 
		enemyHasVTOL = haveIseenVTOLS();
		
	if( enemyHasVTOL === true && (gameTime-VTOLspottedTime) < 600000 && weHaveAA ===true && withChance(personality.defensiveness))
		buildAntiAir();

	// do I need to ask allies for trucks?
	if(enumTrucks().length === 0 && enumStruct(me, "A0LightFactory").length ===0)
		askForTrucks();

	if (enumTrucks().filter(truckFree).length === 0) {
		return;
	}

	if (functionSeries("construction", [
		finishStructures,
		buildOrder,
		buildExpand,
		buildEnergy,
		buildModules,
		buildVtols,
		buildExtras,
		repairBuildings,
		recycleDefenses,
		buildDefenses,
	]))
		queue("checkConstruction");
}

//--------------------------------------------------------------------------
//Used to avoid building derricks on friends oil. If this ally is still alive.
//--------------------------------------------------------------------------
//"borrowed"" from Artillery based AI by  yzmakarov
function isNearFriendlyBase(oilR){
	var checkDistance = 30;
	for(var a = 0; a < playerData.length; a++){
		if(a != me && allianceExistsBetween(a, me)){
			var distanceThem = distBetweenTwoPoints(startPositions[a].x, startPositions[a].y, oilR.x, oilR.y);
			var distanceMe = distBetweenTwoPoints(startPositions[me].x, startPositions[me].y, oilR.x, oilR.y);
			if(distanceThem < checkDistance && distanceMe > checkDistance){
				var friends = enumRange(oilR.x, oilR.y, checkDistance, ALLIES, false).filter(function(obj){  return obj.player == a; })
				if(friends.length > 0){
					return true;
				}
			}
		}
	}
	return false;
}

function askForTrucks(){
	if (throttled(30000)) return;
	if(enumLivingPlayers().filter(isAlly).length > 1) {
		chat(ALLIES,"!nb truck");
	}
	return;
}

_global.defensiveState = function () {
	//How defensive are we feeling?
	var derrickCount = countFinishedStructList(structures.derricks);

	if( derrickCount < 6 ) {
		personality.defensiveness = 10+derrickCount;
		personality.vtolness = 10+derrickCount;
		personality.maxVTOL = 5;
	} else if (derrickCount >= 6)   {
		personality.defensiveness = 40+(derrickCount)/1.5;
		personality.vtolness = 40+(derrickCount)/1.5;
		personality.maxVTOL = 5+Math.floor(derrickCount/3);
	}
	if( enemyHasVTOL === true && (gameTime-VTOLspottedTime) < 600000 && weHaveAA ===true)
		personality.defensiveness = personality.defensiveness + 30 *((600000 - (gameTime-VTOLspottedTime)) / 600000);
		// defensiveness boosted once vtol spotted so more aa can be built
		// but decreases over time 
		
	if(personality.defensiveness >75) personality.defensiveness = 75;
	if(personality.vtolness > 75) personality.vtolness = 75;
}

////////////////////////////////////////////////////////////////////////////////////////////
})(this);
