
/*
 * A few globals that didn't have a place for them in any other file
 *
 */

var baseLocation = startPositions[me];

var base;
var rally;

var areWePanicked;
var haveWePanicked  =false;  // if we have panicked then need to keep more troops close to the base

var enemyHasVTOL;

var VTOLspottedTime = 0;

var specTarget = false;  // has the player specifed a target?
var favTarget = 0; // who's the lucky player

var sensorRecycle = 0;
var borgRegroup = 0;
var borgRegroup2 = 0;
var tankRegroup = 0;

function distanceToBase(loc) {
	return distance(loc, base.x3,base.y3);
}

function canReachFromBase(propulsion, location) {
	if (defined(propulsion))
		return propulsionCanReach(propulsion, base.x3, base.y3, location.x, location.y);
}

function myPower() {
	return playerPower(me) - queuedPower(me);
}

function isAvailable(stat) {
	return isStructureAvailable(stat, me);
}

function isAlly(player) {
	return allianceExistsBetween(me, player);
}

function isEnemy(player) {
	return !isAlly(player);
}

function enumLivingPlayers() {
	function uncached() {
		var ret = [];
		for (var i = 0; i < maxPlayers; ++i) {
			if (countStructList(targets, i) > 0) {
				ret.push(i);
				continue;
			}
			if (enumDroid(i).length > 0)
				ret.push(i);
		}
		return ret;
	};
	return cached(uncached, 30000);
}

function enumTrucks() {
	return enumDroid(me, DROID_CONSTRUCT);
}

function goEasy() {
	personality = randomItem(subpersonalities);
}

function patrolVTOL(){ //lets pick  two points for the idle VTOLS to patrol close to the base
	function uncached() {
		var base = calculateLocation(), x1 , y1, x2, y2;
		if(abs(base.x1) + abs(base.y1) > 0 ) {   //we're in a corner 
			x1 = base.x3 + (10 * base.x1)+(15* base.y1);
			y1 = base.y3 + (10 * base.y1)-(15* base.x1);
			x2 = base.x3 + (10 * base.x1)-(15* base.y1);
			y2 = base.y3 + (10 * base.y1)+(15* base.x1);
			} else {  //we're somewhere central
			x1 = base.x3 + 10;
			y1 = base.y3 - 10;
			x2 = base.x3 - 10;
			y2 = base.y3 + 10;
		}			
		return {x1:x1,x2:x2,y1:y1,y2:y2};
	}
	return cached(uncached, Infinity);
	}
	

function calculateLocation() {
	// this shouldn't change too often
	function uncached() {
		var x1=0,y1=0,x2,y2,x3,y3;  // default assumes somewhere aproximately central
		if(baseLocation.x < 50  && baseLocation.x < mapWidth -50) {
			//we're on W edge
			x1 = 1;
			x2 = 0;
		} else if(baseLocation.x > mapWidth -50 && baseLocation.x > 50) {
			//we're on the E edge
			x1 = -1;
			x2 = mapWidth;
		} else {
			x1 = 0;  //We're somewhere else
			x2 = baseLocation.x;
		}
		if(baseLocation.y < 50 && baseLocation.y <mapHeight -50) {
			//we're on N edge
			y1 = 1;
			y2 = 0;
		} else if(baseLocation.y > mapHeight -50 && baseLocation.y > 50) {
			//we're on the S edge
			y1 = -1;
			y2 = mapHeight;
		} else  {
			y1 = 0; //We're somewhere else
			y2 = baseLocation.y;
		}
		// what if the base is too close to the edge (advanced base start for some maps)?
		if(baseLocation.x < 10) {
			x3 = 10;
		} else if(baseLocation.x > mapWidth -10){
			x3 = mapWidth -10;
		} else {
			x3 = baseLocation.x;
		}
		if(baseLocation.y < 10) {
			y3 = 10;
		} else  if(baseLocation.y > mapHeight -10){
			y3 = mapHeight -10;
		} else {
			y3 = baseLocation.y;
		}
		return {x1:x1, x2:x2, y1:y1, y2:y2, x3:x3, y3:y3};
		}
	return cached(uncached, Infinity);
}

function baseDiameter (){
	function uncached() {
		// let the base radius increase over time
		var diameter = 1.5 + ((gameTime/3600000) * (personality.defensiveness/200)) ;
		if(diameter>3) 
			diameter = 3;  // otherwise things could get silly(er)
		return  diameter;
	}
	return cached(uncached, 120000);
}

function baseDiameterMin (){
	function uncached() {
		// let the base radius increase over time
		var diameter = 1 + ((gameTime/3600000) * (personality.defensiveness/200)) ;
		if(diameter>2) 
			diameter = 2;  // otherwise things could get silly(er)
		return  diameter;
	}
	return cached(uncached, 120000);
}


function myStrength() {
	function uncached() {
		var list1,list2, ground = 0, vtol = 0;
		list1 = enumDroid(me).filter( function(droid) {return (droid.droidType === DROID_WEAPON || droid.droidType === DROID_CYBORG) && !isVTOL(droid);});
		//list2 = enumDroid(me).filter( function(droid) {return droid.droidType === DROID_WEAPON && isVTOL(droid);});
		if(defined(list1))
			ground = list1.length;
		//if(defined(list2))
		//	vtol = list2.length;
		return ground; //{ground: ground, vtol: vtol};
		
	}
	return cached(uncached, 2000);
}

function haveIseenVTOLS() {
	if (enemyHasVTOL) return true;  // if I've already seen enemy vtols then don't need to check again

	var list = enumArea(0,0,mapWidth-1,mapHeight-1, ENEMIES,true).filter( function(droid) {
		return droid.type === DROID && droid.droidType === DROID_WEAPON && isVTOL(droid);
		}); 
	// can I see any enemy vtols on the map?
	if(defined(list))
		if(list.length > 0) {
			enemyHasVTOL = true;
			VTOLspottedTime = gameTime;
			VTOLspotted();
			return true;
		}
	return false;
}

function VTOLspotted(){
	if(enumLivingPlayers().filter(isAlly).length > 1) {
		chat(ALLIES,"!nb defVTOL");
	}
	return;
}

function areThereGW(){
	function uncached() {	//should only need to be evaluated once at the start
		if(enumGateways().length >0) 
			return true;
		return false;
	}
	return cached(uncached, Infinity);
}


function destroyableFeatures() {
	function uncached() {
		var destroyable = enumFeature(ALL_PLAYERS).filter(function(e){if(e.damageable) return true;return false;});
		return destroyable;
	}
	return cached(uncached, 1000);
}		

function meanClosestEnemy(enemy){
	function uncached() {
		//what are the distances between starting positions?
		var ret=[];
		var sumDist=0;
		var nAllies = enumLivingPlayers().filter(isAlly).length;
		var meanDist=0;
		for(var j=0;j<maxPlayers;++j){
			if(!isEnemy(j) && (countStructList(targets, j) > 0 )){//|| enumDroid(j).length > 0)){
				sumDist = sumDist + distance(startPositions[enemy].x,startPositions[enemy].y,startPositions[j].x,startPositions[j].y);
				}
		}
		meanDist=(sumDist/nAllies);
		return meanDist;
	}
	return cached(uncached, 30000);
}

function mapTer(){
	function uncached() {
		// a rought attempt to identify the type of map
		// on a map with a larg flatish area in the middle for allies might be better to rush a single target
		// if the area is broken up then focus on individual targets
		var cliffCount=0;
		var waterCount=0;
		var ret = true;
		for(var i = Math.floor(mapWidth *0.2); i < Math.floor(mapWidth *0.8); ++i){
			for(var j = Math.floor(mapHeight *0.2); j < Math.floor(mapHeight *0.8); ++j){
				if(terrainType(i,j) === TER_CLIFFFACE)
					cliffCount = cliffCount+1;  
				if(terrainType(i,j) === TER_WATER)
					waterCount = waterCount+1;
				if(cliffCount > (Math.floor(mapWidth *0.6) * Math.floor(mapHeight *0.6))*0.05)
					break;
				if( waterCount > (Math.floor(mapWidth *0.6) * Math.floor(mapHeight *0.6))*0.15)
					break;
			}
		}
		//cliffPer= cliffCount / (Math.floor(mapWidth *0.6) * Math.floor(mapHeight *0.6));
		//waterPer= waterCount / (Math.floor(mapWidth *0.6) * Math.floor(mapHeight *0.6));
		//what are reasonable counts for cliffs and water? 
		// 5% for cliffs and 15% for water?
		// just focusing on the central map region 
		// a map like "thePit" has a lot of cliffs but these are on the periphery or around the starting locations
		// whereas a map like "concrete" has a lot of water and cliffs in the centre of the map
		if(cliffCount > (Math.floor(mapWidth *0.6) * Math.floor(mapHeight *0.6))*0.05 || waterCount > (Math.floor(mapWidth *0.6) * Math.floor(mapHeight *0.6))*0.15)
			ret =false;
		
		return ret;
	}
	return cached(uncached, Infinity);
	
}

function vtolCanHit(droid, obj) {
	if (typeof(obj) === DROID && isVTOL(obj))
		return droid.canHitAir;
	else
		return droid.canHitGround;
}

//rally point for def group
// need to put them somewhere useful  but not with a cliff between them and base

function whereToRally() {
	function uncached() {
		var g;
		var r;
		var minX, minY, minDist;
		var ret = { xav: [], yav: []};
		var x2,y2;
		var angle = 0;
		var badTile = false;
		var x,y;


		for(var h =0; h< 11; ++h){
			//slowly expand the radius
			r = Math.floor(baseScale/2)+h;
			for(var i =0; i<20; ++i){
				//with the new radius check for suitable spots for defGroup to muster
				//badTile = true;
				angle = angle + (2*Math.PI)*(i/20);
				y = Math.floor( base.y3 + r * Math.sin( angle ) );
				x = Math.floor( base.x3 + r * Math.cos( angle ) );
				if(x > 3 && x < mapWidth-5 && y > 3 && y < mapHeight-5){
					badTile = false;
				} else
					badTile = true;
				
				if(badTile === false) {
					// is there a cliff or water between this point and base location?
					for(var j =0; j <= r; ++j){
						y2 = Math.floor( base.y3 + j * Math.sin( angle ) );
						x2 = Math.floor( base.x3 + j * Math.cos( angle ) );

						if(terrainType(x2,y2) !== TER_CLIFFFACE && terrainType(x2-1,y2-1) !== TER_CLIFFFACE && 
								terrainType(x2+1,y2+1) !== TER_CLIFFFACE && terrainType(x2-1,y2+1) !== TER_CLIFFFACE &&
								terrainType(x2+1,y2-1) !== TER_CLIFFFACE && terrainType(x2,y2) !== TER_WATER &&
								terrainType(x2-1,y2-1) !== TER_WATER && terrainType(x2+1,y2+1) !== TER_WATER && 
								terrainType(x2-1,y2+1) !== TER_WATER && terrainType(x2+1,y2-1) !== TER_WATER){
							badTile = false;
						} else {
							badTile =true;
							j=r;
						}
					}
				}
				if(badTile === false){
					for(var j =0; j < 6; ++j){
						for(var k =0; k < 6; ++k){		
							x2 = x + (j-3);
							y2 = y + (k-3);
							if(terrainType(x2,y2) !== TER_CLIFFFACE && terrainType(x,y) !== TER_WATER){
								badTile =false;
							} else {
								badTile = true;
								k=6;
								j=6;
							}
						}
					}
				}
				if(badTile === false){
					ret.xav.push(x);
					ret.yav.push(y);	
				}
			}
		}
	
		if(ret.xav.length === 0){
			// fallback option if all else fails
			minX == base.x3+base.x1*8;
			minY == base.y3+base.y1*8;
		}else {
			for(var i =0; i< ret.xav.length; ++i){
				if(i === 0) {
					minDist = distance(ret.xav[i], ret.yav[i],mapWidth/2,mapHeight/2);
					minY = ret.yav[i];
					minX = ret.xav[i];
				}else if( distance(ret.xav[i], ret.yav[i],mapWidth/2,mapHeight/2) < minDist){
					minY = ret.yav[i];
					minX = ret.xav[i];
					minDist = distance(ret.xav[i], ret.yav[i],mapWidth/2,mapHeight/2);
				}
			}
		}
		
		return {x: minX, y: minY};	
		}
	return cached(uncached, Infinity);
	
}		
