
/*
 * This file is responsible for moving combat unit around.
 *
 */

(function(_global) {
////////////////////////////////////////////////////////////////////////////////////////////

_global.MAX_GROUPS = maxPlayers;
_global.borgGroup = MAX_GROUPS;  // resistance is futile
_global.miscGroup = borgGroup + 1; //
_global.defGroup = miscGroup + 1;	// base defence group
_global.vtolGroup = defGroup + 1;	// vtols
_global.recGroup = vtolGroup + 1; // tanks to recycle
// cyborgs moved to own group once switch to hover happens (s) since they can't swim 
// group movement is messed up with both hovers and cyborgs when it comes to crossing bodies of water


var groupInfo = [];
var firstTimeHarass = true;

var setTime=[];
for(var i =0; i<vtolGroup;++i){
	setTime[i] = 0;
}

function GroupInfo() {
	this.lastAttacked = undefined; // gameTime at the moment of the last combat
}

function safeGetObject(label) {
	var obj = getObject(label);
	if (obj === null)
		return undefined;
	return obj;
}

function groupsBySize() {
	var ret = [];
	for (var i = 0; i < MAX_GROUPS+1; ++i){
		if (isEnemy(i))
			ret.push(i);
		}
	//chat(ALLIES, ret[0] + "~" + ret[1] + "~" + ret[2] + "~" + ret[3]);
	ret.sort(function(one, two) { return groupSize(two) - groupSize(one); });
	return ret;
}


function findLargestGroupIn(list) {
	var sizes = []
	for (var i = 0; i < MAX_GROUPS+1; ++i)
		sizes[i] = 0;
	list.forEach(function(object) {
		if (!defined(object.group) || object.group < 0 && object.group >= MAX_GROUPS+1)
			return;
		++sizes[object.group];
	});
	var maxCount = 0, maxIdx = 0;
	for (var i = 0; i < sizes.length; ++i)
		if (sizes[i] > maxCount) {
			maxCount = sizes[i];
			maxIdx = i;
		}
	return maxIdx;
}

function findNearestGroup(x, y) {
	var ret = naiveFindClusters(enumDroid(me).filter(function(droid) {
		return !isVTOL(droid) && droid.group !== defGroup && (droid.droidType === DROID_WEAPON || droid.droidType === DROID_CYBORG || droid.droidType ===DROID_SENSOR ||
			droid.droidType === DROID_ECM ||droid.droidType === DROID_REPAIR || droid.isCB === true);
	}), baseScale / 3);
	if (ret.maxCount === 0)
		return undefined;
	var minDist = Infinity, minIdx;
	var gr = [];
	for (var i = 0; i < ret.clusters.length; ++i) {
		gr[i] = findLargestGroupIn(ret.clusters[i]);
		if (groupSize(gr[i]) > attackGroupSize()) {
			var dist = distance(ret.xav[i], ret.yav[i], x, y);
			if (dist < minDist) {
				minDist = dist;
				minIdx = i;
			}
		}
	}
	if (defined(minIdx))
		return gr[minIdx];
	gr = groupsBySize();
	if (gr.length > 0)
		if (groupSize(gr[0]) > attackGroupSize())
			return gr[0];
}

function targetSuitableForHarass(object) {
	function uncached() {
		var ret = enumRange(object.x, object.y, baseScale / 2, ENEMIES, false).filter(function(obj) {
			return !(obj.type == STRUCTURE && obj.stattype != DEFENSE);
		}); //}).length;
		if(scavengerPlayer!=-1)
			ret.concat(enumRange(object.x, object.y, baseScale / 2, scavengerPlayer, false).filter(function(obj) {
				return !(obj.type == STRUCTURE && obj.stattype != DEFENSE); }));//.length
		return ret.length <= groupSize(miscGroup);
	}
	return cached(uncached, 60000, object.id);
}

function getGroupInfo(gr) {
	if (defined(groupInfo[gr]))
		return groupInfo[gr];
	groupInfo[gr] = new GroupInfo();
	return groupInfo[gr];
}

function groupTargetLabel(gr) {
	return "darkBot_" + me + "_GroupTarget_" + gr;
}

function groupMicroTargetLabel(gr) {
	return "darkBot_" + me + "_GroupMicroTarget_" + gr;
}

function vtolTargetLabel() {
	return "darkBot_" + me + "_VtolTarget";
}

_global.findTarget =  function (gr) {

	var obj = safeGetObject(groupMicroTargetLabel(gr));
	var obj2 = safeGetObject(groupTargetLabel(gr));
	getGroupInfo(gr);
	
	if(areWePanicked ===true || gr ===defGroup && enemiesAreHere ===true){
		//for all ground based groups if panicked else just def group if the enemy are at the gates
		list = locateEnemies().sort( function(i,j) {return distanceToBase(i) - distanceToBase(j);}); 
		if(list.length>0) {
			obj2 = list[0];
		}
	}
	//if(enemiesAreHere ===true && gr === defGroup)
	//	obj = baseDefence();

	if (gameTime > groupInfo[gr].lastAttacked + 5000 && defined(obj) && obj.type === POSITION){
		removeLabel(groupMicroTargetLabel(gr));
	}

	if (gameTime > groupInfo[gr].lastAttacked + 10000 && defined(obj2) && obj2.type === POSITION){
		removeLabel(groupMicroTargetLabel(gr));
	}
	
	if(defined(obj2) && obj2.type === POSITION && gameTime > setTime[gr] + 57000){
		removeLabel(groupTargetLabel(gr));
		obj2 = safeGetObject(groupTargetLabel(gr));
	}
	if (!defined(obj))
		obj = obj2;
	if (defined(obj)) {
		if (gr === miscGroup) {
			// harass group should switch targets when its target gets protected, otherwise targets are permanent
			if (throttled(10000) || targetSuitableForHarass(obj))
				return obj;
		} else
			return obj;
	}
	// find harass targets for the misc group
	if (gr === miscGroup) {
		var list = enumStructList(miscTargets, enumLivingPlayers().filter(isEnemy).random());
		powerUps.forEach(function(stat) { // pick up oil drums and artifacts
			list = list.concat(enumFeature(-1, stat));
		});
		list = list.filter(targetSuitableForHarass).filter(function(feature) {
			if (iHaveHover())
				if (canReachFromBase(getPropulsionStatsComponents(PROPULSIONUSAGE.HOVER)[0], feature))
					return true;
			return canReachFromBase(getPropulsionStatsComponents(PROPULSIONUSAGE.GROUND)[0], feature);
		}).sort(function(one, two) {
			return distanceToBase(one) - distanceToBase(two);
		});
		obj = list[random(Math.min(3, list.length))];
		if (defined(obj)) {
			addLabel(obj, groupTargetLabel(gr));
			return obj;
		}
	}
	// are there scavs on the map?
	// there is at least one map where a scav base causes pathing issues because it blocks the only exit 
	// (for starting position 0 in Nomansland)
	// the AI will send its troops to the closest point between it and the target
	// if the scav base is in close to this then the scavs will be targeted
	// hoever if the scavs aren't close to this point the the AI's group will just sit and do nothing
	// until the path is cleared by another group or player.
	if(scavengerPlayer!=-1){
		var scavStructs = enumStruct(scavengerPlayer,me);
		//var scavDroids = enumDroid(scavengerPlayer).sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});
	}

	// set borgs on someone
	if (gr === borgGroup) {
		var borgTargets = [];
		var enemy = pickEnemy();
		//chat(ALLIES, enemy[0] + "~" + enemy[1]+ "~" + enemy[2]+ "~" + enemy[3]);
		enemy = enemy.filter( function (target) {
			return canReachFromBase(getPropulsionStatsComponents(PROPULSIONUSAGE.GROUND)[0], startPositions[target]);
			});
		//chat(ALLIES, enemy[0] + "~" + enemy[1]+ "~" + enemy[2]+ "~" + enemy[3]);
		targets.forEach(function(stat) {borgTargets=borgTargets.concat(enumStruct(enemy[0],stat,me)); });
		if(scavStructs.length>0){
			var scavTargets = scavStructs.filter( function (target) {
				return canReachFromBase(getPropulsionStatsComponents(PROPULSIONUSAGE.GROUND)[0], target);
				});
			borgTargets = borgTargets.concat(scavTargets);
		}
		borgTargets.sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});			
		if(borgTargets.length>0){
			obj = borgTargets[0];
		} else if (enemy.length > 0) {
			obj = { x: startPositions[enemy[0]].x, y: startPositions[enemy[0]].y, type: POSITION};
			setTime[gr] = gameTime;
		}// else {
		//	list2 = enumDroid(enemy, me).sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});
		//	obj = list2[0];
		//}
		
	}

	if(gr < MAX_GROUPS){
		// check if enemy is alive 
		if(countStructList(targets, gr) > 0 ){//|| enumDroid(gr).length > 0) {
			var list = [];
			var list2 =[];
			var scavTargets;
			targets.forEach(function(stat) {list=list.concat(enumStruct(gr,stat,me)); });

			if(scavStructs.length>0){
				// if the scavtarget is on the way to our main target
				scavTargets = scavStructs.filter(function (i) {
					return distance(i, startPositions[gr]) < distance(startPositions[me],startPositions[gr]) && distanceToBase(i) < distanceToBase(startPositions[gr]);
				});
				if(scavTargets.length >0)
					list = list.concat(scavTargets);
			}
			if(list.length >0){
				list.sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});
				obj = list[0];//.random()
			} else if(countStructList(targets, gr) > 0 && list.length === 0){
				//if can't see buildings but target is still alive then go for start position.
				obj = { x: startPositions[gr].x, y: startPositions[gr].y, type: POSITION};
				setTime[gr] = gameTime;
			}// else {
			//	list2 = enumDroid(gr, me).sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});
			//	obj = list2[0];
			//}
			
		}
	}
	
	if(gr === defGroup)
		obj = baseDefence();
		
	if (defined(obj)) {
		addLabel(obj, groupTargetLabel(gr));
		return obj;
	}
}

function groupInDanger(gr) {
	getGroupInfo(gr); // make sure everything is defined
	if (!defined(groupInfo[gr].lastAttacked))
		return false;
	return gameTime - groupInfo[gr].lastAttacked < 10000;
}

function regroup(gr) {
	if (areWePanicked ===true || gr ===defGroup)
		return enumGroup(gr).filter(checkRepaired);

	var size = attackGroupSize();
	if (size < groupSize(gr) / 2)
		size = groupSize(gr) / 2;
	var ret = naiveFindClusters(enumGroup(gr).filter(checkRepaired), (baseScale / 3));
	if (ret.maxCount === 0)
		return [];
	for (var i = 0; i < ret.clusters.length; ++i)
		if (i !== ret.maxIdx) 
			for (var j = 0; j < ret.clusters[i].length; ++j)
				orderDroidLoc(ret.clusters[i][j], DORDER_MOVE, ret.xav[ret.maxIdx], ret.yav[ret.maxIdx]);  
	if (ret.maxCount < size) {
		for (var j = 0; j < ret.clusters[ret.maxIdx].length; ++j) {
			if (groupInDanger(gr)) 
				orderDroidLoc(ret.clusters[ret.maxIdx][j], DORDER_MOVE,base.x3,base.y3);
			else
				orderDroid(ret.clusters[ret.maxIdx][j], DORDER_STOP);
		}
		return [];
	}
	return ret.clusters[ret.maxIdx];
}

function weHaveRepair() {
	function uncached() {
		return enumStruct(me, REPAIR_FACILITY).length > 0;
	}
	return cached(uncached, 1000);
}

function checkRepaired(droid) {
	if (!weHaveRepair())
		return true;
	if (droid.order === DORDER_RTR)
		return false;
	if (droid.health < personality.repairAt && droid.propulsion !== "hover01"|| droid.health < personality.repairAt+15 && droid.propulsion !== "hover01") {
		orderDroid(droid, DORDER_RTR);
		return false;
	}
	return true;
}

function droidFree(droid) {
	if (droid.order === DORDER_SCOUT)
		return false;
	if (droid.order === DORDER_ATTACK)
		return false;
	if (droid.order === DORDER_RTR)
		return false;
	if (!checkRepaired(droid))
		return false;
	return true;
}

function attackTarget(droid,target) {
	//var target = findTarget(droid.group);
	if(!defined(droid)) return;
	if (droid.group !== miscGroup)
		if (!defined(target) || !droidCanReach(droid, target.x, target.y)) {
			groupDroid(droid);
			return;
		}
	if (defined(target))
		switch (target.type) {
			case DROID:
				if (droid.canHitGround ===true && !isVTOL(target))
					orderDroidObj(droid, DORDER_ATTACK, target);
				else if(droid.canHitAir ===true && isVTOL(target))
					orderDroidObj(droid, DORDER_ATTACK, target);
				else if (droid.droidType === DROID_REPAIR){
					var list = enumGroup(droid.group).filter( function(i) {return i !== droid && i.health <100;}).sort( 
						function (i,j) {return i.health -j.health;});
					if(defined(list) && list.length>0 && list[0].health <100)
						orderDroidObj(droid, DORDER_REPAIR, list[0]);
					else
						orderDroidObj(droid, DORDER_OBSERVE, target);
					}
				else
					orderDroidObj(droid, DORDER_OBSERVE, target);
				break;
			case FEATURE:
				if(target.damageable ===true && droid.canHitGround ===true)
					orderDroidObj(droid, DORDER_ATTACK, target);
				else if( target.stattype === OIL_DRUM || target.stattype === ARTIFACT)				
					orderDroidObj(droid, DORDER_RECOVER, target);
				else 
					orderDroidObj(droid, DORDER_OBSERVE, target);
				break;
			case STRUCTURE:
				if (droid.droidType === DROID_WEAPON || DROID_CYBORG)
					orderDroidLoc(droid, DORDER_SCOUT, target.x, target.y);
				else if (droid.droidType === DROID_REPAIR){
					var list = enumGroup(droid.group).filter( function(i) {return i !== droid && i.health <100;}).sort( 
						function (i,j) {return i.health -j.health;});
					if(defined(list) && list.length>0 && list[0].health <100)
						orderDroidObj(droid, DORDER_REPAIR, list[0]);
					else
						orderDroidObj(droid, DORDER_OBSERVE, target);
					}
				else 
					orderDroidObj(droid, DORDER_OBSERVE, target);
				break;
			default:
				if (droid.droidType === DROID_WEAPON || DROID_CYBORG)
					orderDroidLoc(droid, DORDER_SCOUT, target.x, target.y);
				else 
					orderDroidLoc(droid, DORDER_MOVE, target.x, target.y);
				break;
		}
}


function vtolArmed(obj, percent) {
	if (obj.type != DROID)
		return;
	if (!isVTOL(obj))
		return false;
	for (var i = 0; i < obj.weapons.length; ++i)
		if (obj.weapons[i].armed >= 99)
			return true;
	return false;
}

function vtolReady(droid) {
	if (droid.order === DORDER_ATTACK)
		return false;
	if (droid.order === DORDER_SCOUT)
		return false;
	if (droid.order === DORDER_PATROL)
		return true;	
	if (vtolArmed(droid, 99))
		return true;
	if (droid.order !== DORDER_REARM) {
		orderDroid(droid, DORDER_REARM);
		buildVtols() // actually pads
	}
	return false;
}

_global.attackGroupSize = function() {
	var harder;
	if(personality.hitandrun===true && componentAvailable("hover01"))
		harder = 2;
	else
		harder = personality.becomeHarder;

	var ret = personality.minTanks + (gameTime / 300000) * harder;
	if (ret > personality.maxTanks)
		ret = personality.maxTanks;
	return ret;
}

_global.defGroupSize = function() {
	var ret = 3 + Math.floor(gameTime / 600000) * personality.becomeHarder;
	if (ret > Math.floor(personality.maxTanks *0.75))
		ret = Math.floor(personality.maxTanks *0.75);
	return ret;
}


_global.attackGroupSizeVTOL = function() {
  // vtols become available later in game (unless on a t2 or t3 start)
	var ret = personality.minVTOL + Math.floor((gameTime - personality.VTOLtime)/900000);
	if (ret > personality.maxVTOL)
		ret = personality.maxVTOL;
	return ret;
}


_global.setTarget = function(object, group,attacked,help) {
	if (!defined(group) || group === "any") {
		group = findNearestGroup(object.x, object.y);
		if (groupSize(vtolGroup)>0 ){
			addLabel(object, vtolTargetLabel());
			setTime[vtolGroup] = gameTime;
		}
	}
	if (!defined(group))
		return false;
	if(!defined(attacked))
		attacked = false;
	if(!defined(help))
		help = false;
	if (defined(safeGetObject(groupTargetLabel(group))))
		if (throttled(8000, group) && areWePanicked === false && help === false) // don't switch targets too often
			return false;
	if (object.type === DROID || (object.type === STRUCTURE && object.stattype === DEFENSE))
		addLabel(object, groupMicroTargetLabel(group));
	else if(object.type === POSITION && attacked === true)
		addLabel(object, groupMicroTargetLabel(group));
	else{
		addLabel(object, groupTargetLabel(group));
		setTime[group] = gameTime;
	}	
	return true;
}

_global.unsetTarget = function(player) {
	for (var i = 0; i <= MAX_GROUPS+1; ++i) {
		var obj = safeGetObject(groupTargetLabel(i));
		if (defined(obj) && player === me){ 
			removeLabel(groupTargetLabel(i));
			removeLabel(groupMicroTargetLabel(i));
			setTime[i] = 0;
		}		
		if (defined(obj) && obj.type === POSITION && findBeaconPlayer(obj.x, obj.y) === player ||
			defined(obj) && obj.type === POSITION && distance(obj.x, obj.y, startPositions[player].x,startPositions[player].y) < baseDiameter()*baseScale *1.5){ 
			//  && findBeaconPlayer(obj.x, obj.y) === player){ //&& obj.type === POSITION
			removeLabel(groupTargetLabel(i));
			removeLabel(groupMicroTargetLabel(i));
			setTime[i] = 0;
		}
	}
	removeLabel(vtolTargetLabel);
	setTime[vtolGroup] = 0;
}

_global.groupDroid = function(droid) {
	if(!defined(droid)) return;
	// VTOL droid
	if (isVTOL(droid)) {
		groupAdd(vtolGroup, droid);
		return;
	}

	if (droid.droidType !== DROID_CONSTRUCT) {
		if(enemiesAreHere === true || areWePanicked ===true){
			if(droid.canHitGround ===true) {
				groupAdd(defGroup, droid);
				return;
			}
		}
		
		// misc group both borgs and tanks
		if (withChance(50 - 50 * (groupSize(miscGroup)/ personality.maxMiscTanks))  && droid.canHitGround ===true && droid.hasIndirect ===false || 
			firstTimeHarass && droid.canHitGround ===true && droid.hasIndirect ===false) {
			firstTimeHarass = false;
			groupAdd(miscGroup, droid);
			return;
		}
		
		// base defence group
		// goal is to slow attackers so that other groups can return
		if(haveWePanicked === false)
			var defChance = 25;
		else
			var defChance =75;
			
		if(withChance(defChance) && haveWePanicked === false && droid.droidType === DROID_WEAPON && droid.canHitGround ===true && 
				groupSize(defGroup) < defGroupSize() && myStrength() > attackGroupSize()+2 ||
				withChance(defChance) && haveWePanicked ===true && droid.droidType === DROID_WEAPON && 
				droid.canHitGround ===true && groupSize(defGroup) < defGroupSize()){ 
			groupAdd(defGroup, droid);
			return;
		}
	
		if(personality.hitandrun===true && componentAvailable("hover01")){
			// borg group (to prevent pathing issues with bodies of water and borgs
			if (droid.droidType === DROID_CYBORG || droid.name === "Cyb-Mechanic" || droid.droidType === DROID_WEAPON && droid.propulsion !== "hover01") {
				groupAdd(borgGroup, droid);
				return;
			}
		} 

		var grp = pickEnemy().filter(function(target) {
			if (iHaveHover() && personality.hitandrun===true)
				if (propulsionCanReach("hover01", base.x3,base.y3, startPositions[target].x,startPositions[target].y))
					return true;
			return propulsionCanReach("wheeled01", base.x3,base.y3, startPositions[target].x,startPositions[target].y);
		});
		//chat(ALLIES, grp[0] + "~" + grp[1]+ "~" + grp[2]+ "~" + grp[3]);
		
		var ret = grp.filter(function(i) {return groupSize(i) < attackGroupSize() * 2 && defined(findTarget(i)); });
		if (ret.length === 0)
			ret = grp;
		if (ret.length === 0)
			ret = [ miscGroup ];
		groupAdd(ret[0], droid);
	}
}

_global.rebalanceGroups = function() {

	var scope = scopeRatings();
	
	if (throttled(5000))
		return;
	//do we need to rebalance groups if we're panicked? 
	if(areWePanicked ===true || enemiesAreHere ===true)
		return;
		
	//if (!throttled(10000)) return false;
	// identify without hover when personality prefers hover and move them to borg group
	// using tankRegroup, borgRegroup and sensorRecycle to ensure that it doesn't call these options too often
	// if a player uses chat to set hover off then these values are reset to zero
	// Once conditions are met new droids are assinged to the appropriate groups so should not need to be called too often
	if(tankRegroup< 5 && !throttled(45000, "borgGrouping")){
		if(personality.hitandrun===true && componentAvailable("hover01")){
			var list = enumDroid(me).filter( function(droid) { 
				return droid.propulsion !== "hover01" && droid.droidType !== DROID_CYBORG && droid.droidType !== DROID_CONSTRUCT && 
				!isVTOL(droid) && droid.group !== borgGroup && droid.group !== defGroup; 
				});
				++tankRegroup;
			if(defined(list) && list.length > 0 ){
				for(var i =0; i<list.length; ++i){
					groupAdd(borgGroup,list[i]);
				}
			}
		}
	}

	if(sensorRecycle <5 && !throttled(45000, "borgGrouping2")){
		if(personality.hitandrun===true && componentAvailable("hover01") || scope.land === 0 && componentAvailable("hover01")){
			var list = enumDroid(me).filter( function(droid) { 
				return droid.propulsion !== "hover01" && (droid.droidType ===DROID_SENSOR || droid.droidType === DROID_REPAIR || droid.droidType === DROID_ECM); 
				});
				++sensorRecycle;
			if(list.length > 0 && countStruct(structures.factories)>0) {
				for(var i =0; i<list.length; ++i){
					groupAdd(recGroup, list[i]);
					orderDroid(list[i], DORDER_RECYCLE);
				}
			}
		}
	}

	//once we start producing hovers lets move the borgs to their own group
	if(borgRegroup < 5 && !throttled(60000, "borgGrouping3")){
		if(personality.hitandrun===true && componentAvailable("hover01")){
			++borgRegroup;
			var list = enumDroid(me).filter( function(droid) {return droid.droidType === DROID_CYBORG && droid.group < MAX_GROUPS;});
			if(defined(list) && list.length > 0 ){
				for(var i =0; i<list.length; ++i){
					groupAdd(borgGroup,list[i]);
				}
			}
		}
	}	

	// reassign the borg group is player sets hovers to no hovers
	if(borgRegroup2 < 5 && !throttled(65000, "borgGrouping4")){
		if(personality.hitandrun===false && groupSize(borgGroup) > 0){
			++borgRegroup2;
			var list = enumGroup(borgGroup);
			if(defined(list) && list.length > 0 ){
				for(var i =0; i<list.length; ++i){
					groupDroid(list[i]);
				}
			}
		}
	}	

		
	if (groupSize(miscGroup) > personality.maxMiscTanks ) {
		var list = enumGroup(miscGroup).shuffle();
		groupDroid(list[0]);
	}

	// shuffle the defence group so that older vehilces can be moved out to allow newer ones in
	if(groupSize(defGroup) > Math.floor(defGroupSize())-1 && enemiesAreHere ===false){
		var list = enumGroup(defGroup).shuffle();
		for(var i=0; i < list.length -defGroupSize()+1;++i){
			groupDroid(list[i]);	
		}	
	}


	var grp = pickEnemy();

	//ret=grp;
	//chat(ALLIES,"rebalance: "+ grp[0] + "~" + grp[1]+ "~" + grp[2]+ "~" + grp[3]);
	if (grp.length > 0){
		if (groupSize(grp[0]) > 0 && groupSize(grp[0]) < attackGroupSize()){
			var target = findTarget(grp[0]);
			if (defined(target)){
				for (var i = 1; i < grp.length; ++i) {
					var list = enumGroup(grp[i]);
					for (var j = 0; j < list.length; ++j) {
						if (droidCanReach(list[j], target.x, target.y)) {
							groupAdd(grp[0], list[j]);
							return;
						}
					}
				}
			}
		}
	}
}

_global.touchGroup = function(gr) {
	getGroupInfo(gr); // make sure everything is defined
	groupInfo[gr].lastAttacked = gameTime;
}

_global.fallBack = function(droid, threat) {
	if (droid.order === DORDER_MOVE)
		return;
	if (guessDroidMicro(droid) === MICRO.MELEE)
		return;
	var x = droid.x - (baseScale / 7) * (threat.x - droid.x) / distance(threat, droid);
	var y = droid.y - (baseScale / 7) * (threat.y - droid.y) / distance(threat, droid);
	if (x < 1 || y < 1 || x > mapWidth - 2 || y > mapHeight - 2)
		return;
	if(droid.droidType === DROID_WEAPON)
		orderDroidLoc(droid, DORDER_SCOUT, x, y);
	else		
		orderDroidLoc(droid, DORDER_MOVE, x, y);
}

_global.dangerLevel = function(loc) {
	return enumRange(loc.x, loc.y, baseScale / 2, ENEMIES, false).length;
}

_global.checkAttack = function() {
	if( enumLivingPlayers().filter(isEnemy).length === 0 )
		return;
	var target;  // in late game when there are many tanks AI can slow down as it attacks
	// nullbot uses a regroup(i).foreach(attack) which evaluates findTarget for each droid
	for (var i = 0; i < MAX_GROUPS; ++i)
		if (!throttled(2019, i)) {
			if(groupSize(i) > 0){
				target = findTarget(i);
				regroup(i).forEach(function(droid) {return attackTarget(droid,target);});
				break;
			}
		}
		
	if(!throttled(1550, "borg") && groupSize(borgGroup)>0){
		target = findTarget(borgGroup);
		regroup(borgGroup).forEach(function(droid) {return attackTarget(droid,target);});
		}
		
	if(!throttled(2330, "def") && groupSize(defGroup)>0){
		target = findTarget(defGroup);
		regroup(defGroup).forEach(function(droid) {return attackTarget(droid,target);});
		}

		
	if (!throttled(1120, "misc"))
		target = findTarget(miscGroup);
		enumGroup(miscGroup).filter(checkRepaired).forEach(function(droid) {return attackTarget(droid,target);});
}	
			
_global.checkAttackVTOL = function() {
	// a little bit less cheating for the vTOL targeting
	// but it still knows where you started and where the oils are
	if( enumLivingPlayers().filter(isEnemy).length === 0 )
		return;

	var droids = enumGroup(vtolGroup).filter(vtolReady);
	if(droids.length > 0){
		if(areWePanicked===true || enemiesAreHere ===true) {
			var enemies = locateEnemies().sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});
			droids.forEach(function(droid) {
				var target = enemies.random();
				if (defined(target) && droid.canHitGround === true)
					orderDroidObj(droid, DORDER_ATTACK, target);
			});
			return;					
		}

		if (droids.length >= attackGroupSizeVTOL() && areWePanicked===false && enemiesAreHere ===false){
			
			// do we need to target lassats?
			//if(difficulty === INSANE || difficulty === HARD ){
				var lasSatTargets= [];
				for(var i =0; i<maxPlayers; ++i){
					if(isEnemy(i)){
						lasSatTargets=lasSatTargets.concat(enumStruct(i,"A0LasSatCommand",me));
					}
				}
				if(lasSatTargets.length>0){
					lasSatTargets.sort(function(x) {return x.born;}).reverse();
					droids.filter(function(droid){return droid.canHitGround ===true;}).forEach(function(droid) 
						{orderDroidObj(droid, DORDER_ATTACK, lasSatTargets[0]);});
					return	;
				}
			//}

			// beacon dropped by allied player
			var obj = safeGetObject(vtolTargetLabel);
			if(defined(obj)  && gameTime - setTime[vtolGroup] < 90000)	{
				droids.forEach(function(droid) {orderDroidLoc(droid, DORDER_SCOUT, obj.x,obj.y);});
				return;
			}
			
			// targetting any scavs
			if(withChance(15) && scavengerPlayer !== -1){
				var scavStructs = enumStruct(scavengerPlayer,me).sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});
				if(scavStructs.length > 0){
					droids.forEach(function(droid) {orderDroidLoc(droid, DORDER_SCOUT, scavStructs[0].x+random(6)-3,scavStructs[0].y+random(6)-3);});
					return;
				}
			 }
			// targeting sensor blips
			if(withChance(20)){
				var blips = enumBlips(me).sort( function(i,j) {return distanceToBase(i)- distanceToBase(j);});
				if(blips.length > 0){
					droids.forEach(function(droid) {orderDroidLoc(droid, DORDER_SCOUT, blips[0].x,blips[0].y);});
					return;
				}
			}
			// targeting enemy base
			if(withChance(50)){
				var grp = pickEnemy();
				var list= pickVtolTargets(grp);
				if(list.length > 0 ) {
					droids.forEach(function(droid) {
						var targ = list.random();
						if (defined(targ) && droid.canHitGround === true)
						orderDroidObj(droid, DORDER_ATTACK, targ);
					});
					return;
				}
				droids.forEach(function(droid) {orderDroidLoc(droid, DORDER_SCOUT, startPositions[grp[0]].x,startPositions[grp[0]].y);});
				return;
			}
				
			//harras some oil derricks
			if(withChance(75)) {
				var oilTarget=[];  // oil targets
				for(var i =0; i<maxPlayers; ++i){
					if(isEnemy(i)){
						oilTarget=oilTarget.concat(enumStructList(miscTargets,i)).filter(function (oil) {
							return distance(oil.x,oil.y,startPositions[i].x,startPositions[i].y)> baseScale;
							});
					}
				}
				if(scavengerPlayer!=-1)
					oilTarget=oilTarget.concat(enumStructList(miscTargets,scavengerPlayer));
				
				if(oilTarget.length > 0){
					oilTarget.sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});
					droids.forEach(function(droid) {orderDroidLoc(droid, DORDER_SCOUT, oilTarget[0].x,oilTarget[0].y);});
					return;
				}
			}	
				
			//are they being tricksy (or have I run out of other options)?
			var x = random(mapWidth-16)+8;
			var y = random(mapHeight-16)+8;
			droids.forEach(function(droid) {orderDroidLoc(droid, DORDER_SCOUT, x,y);});
		}
			
	}
}	

function pickVtolTargets(grp){
	function uncached() {
		// pick an enmemy structure type to target
		//target aa to start
		var list =[];
		list = enumStruct(grp[0],DEFENSE,me).filter(function (targ) {return targ.canHitAir;});
		if(list.length >0)
			return list;
		// then target sensors
		vtolTargetsSensors.forEach(function(stat) {list=list.concat(enumStruct(grp[0],stat,me)); });
		if(list.length >0)
			return list;
		// artillery targets
		list=enumStruct(grp[0], DEFENSE,me).filter(function (targ) {return targ.hasIndirect;});
		if(list.length >0)
			return list;
		// base structures
		targets.forEach(function(stat) {list=list.concat(enumStruct(grp[0],stat,me)); });
		// if no observed targets then will return an empty list
		return list;
	}
	return cached(uncached, 5000);
}


_global.pushVtols = function(x,y) {
	var vtols = enumRange(x, y, 20, me, false).filter(function(droid) {return droid.type === DROID && isVTOL(droid); });
	if(vtols.length > 0) {
		for (var i = 0; i < vtols.length; ++i){
			if (vtolArmed(vtols[i], 1))
				orderDroidLoc(vtols[i], DORDER_SCOUT, x,y);
		}
	}
}

_global.enemyAtTheGates = function(){
	// do we have enmies close to the base?
	// are there enemies close to the base and should I panic?

	var radius = baseDiameter()*baseScale; 
	if  (areWePanicked === true)
		var scale = 1.25;
	else
		var scale =1;
	var enemies =[];
	var friendlies =[];
	var enemies = locateEnemies(scale).sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});

	if(enemies.length >0){
		var friendlies = enumRange(base.x3, base.y3, radius, ALLIES, true).filter(function(enemies) {
			return enemies.type === DROID && (enemies.droidType === DROID_WEAPON || enemies.droidType === DROID_CYBORG)  && !isVTOL(enemies);});

		if(enemies.length > 0 && 3*enemies.length < 2*friendlies.length){
			if(enemiesAreHere === false)
				enemiesAreHere = true;
		}
	
		if(3*enemies.length > 2*friendlies.length) {
			if(haveWePanicked === false)
				haveWePanicked = true;
			areWePanicked = true;
			askForHelp(enemies[0].x,enemies[0].y);
		}
		if(enemiesAreHere ===true || areWePanicked ===true){
			if(!throttled(20000,"defGrouping")){
				var list = friendlies.filter(function (droid) {
					return droid.player === me &&  droid.canHitGround && droid.group !== defGroup;});
				if(defined(list) && list.length > 0){
					for(var i = 0; i < list.length; ++i){
						if(defined(list[i]))
							groupAdd(defGroup, list[i]);
					}
				}
			}
		}
	}
	if(enemies.length ===0){
		if  (areWePanicked === true) {
			areWePanicked = false;
			sendThanks();
			unsetTarget(me);
		}	
		if(enemiesAreHere === true){
			enemiesAreHere = false;
		}
	}
}

function baseDefence() {
	var scale;
	if  (areWePanicked === true)
		scale = 1.25;
	else
		scale =1;
	var targ;
	//var defenders = enumGroup(defGroup);
	var enemies = locateEnemies(scale).sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});
	if(defined(enemies) && enemies.length>0){
		return enemies[0];
	}
	
	var destroyable =destroyableFeatures().filter(function(obj) {
		return distanceToBase(obj)<baseDiameter()*baseScale*1.25 && canReachFromBase(getPropulsionStatsComponents(PROPULSIONUSAGE.GROUND)[0], obj);});
	if(defined(destroyable) && destroyable.length>0) {
		targ = destroyable.sort(function (i,j) {return distanceToBase(i) - distanceToBase(j);});
		return targ[0];
	} else {
		setTime[defGroup] = gameTime;
		return {x: rally.x,y: rally.y,type: POSITION};
	}
}


function locateEnemies(scale){
	function uncached() {
		//looking for visible enemies close to the base
		var radius = baseDiameter()*baseScale*scale; // it's a larger radius but only visible enemies are identified
		var enemies = enumRange(base.x3, base.y3, radius, ENEMIES, true).filter(function(droid) {
			return droid.type ===DROID && (droid.droidType === DROID_WEAPON || droid.droidType === DROID_CYBORG) && !isVTOL(droid);});
		return(enemies)	
	}
	return cached(uncached, 100);
}

function askForHelp(x,y){
	if (throttled(60000)) return;
		addBeacon(x, y, ALLIES);

	if(enumLivingPlayers().filter(isAlly).length > 1) {
		chat(ALLIES,"!nb help");

	}
	return;
}

function sendThanks (){
	//if (throttled(44000)) return;
	if(enumLivingPlayers().filter(isAlly).length > 1) {
		chat(ALLIES,"!nb tx");
		removeBeacon(ALLIES);
	}
	return;	
}

function pickEnemy() {
	function uncached() {
		if(specTarget ===true && (countStructList(targets, favTarget) ===0 )) {// && enumDroid(favTarget).length ===0)){
			specTarget = false;
		}
		var grp = [];
		var ret = [];		

		for (var i = 0; i < MAX_GROUPS; ++i){
			if (isEnemy(i) && (countStructList(targets, i) >0 ))// || enumDroid(i).length > 0))
				ret.push(i);
		}
		grp = ret.sort(function(i,j) {
			 return distance(startPositions[i].x,startPositions[i].y,base.x3,base.y3)- distance(startPositions[j].x,startPositions[j].y,base.x3,base.y3); 
			 });
		
		// has the player specified a target?
		if(specTarget === true ){
			var grp2=[];
			grp2[0] = favTarget;
			for(var i = 0; i<grp.length; ++i){
				if(i !== favTarget){
					grp2.push(grp[i]);
				}
			}
			grp = grp2;
		}
		//chat(ALLIES, grp[0] + "~" + grp[1]+ "~" + grp[2]+ "~" + grp[3]);

		return grp;
	}
	return cached(uncached, 35000);
}


////////////////////////////////////////////////////////////////////////////////////////////
})(this);
